// override.cpp - LCTextOut

#include <windows.h>
#include <tchar.h>
#include "gdi++.h"

// bNAbve[u(255*9=2295)
BYTE ColorTable3x[2296];
UINT Quality, Weight, UseSubPixel, SubPixelDirection;

// kɎgp郋bNAbve[u
void InitColorTable(void){
	int i;
	// 0`2295܂ł̒l9Ŋ̂LbV
	for(i = 0; i < 2296; i++) ColorTable3x[i] = i / 9;
}

// INIt@Cǂݍ
void LoadSettings(HMODULE hModule){
	TCHAR szFileName[_MAX_PATH + 1] = _T("");
	// DLL̃tpX擾
	GetModuleFileName(hModule, szFileName, _MAX_PATH);
	// gq".ini"ɒu
	lstrcpy(szFileName + lstrlen(szFileName) - 3, _T("ini"));
	// eݒǂݍ
	// INIt@C̗:
	// [General]
	// Quality=1
	// Weight=0
	// UseSubPixel=0
	// SubPixelDirection=0
	Quality = GetPrivateProfileInt(_T("General"),_T("Quality"),1,szFileName);
	Weight = GetPrivateProfileInt(_T("General"),_T("Weight"),0,szFileName);
	UseSubPixel = GetPrivateProfileInt(_T("General"),_T("UseSubPixel"),0,szFileName);
	SubPixelDirection = GetPrivateProfileInt(_T("General"),_T("SubPixelDirection"),0,szFileName);
}

// mȃTCYԂGetTextExtentPoint32
BOOL GetTextExtentPoint32Ex(HDC hdc, LPVOID lpString, int cbString, LPSIZE lpSize, bool IsANSI)
{
	int TextExtra;
	HDC hCanvasDC;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	SIZE sizeString;

	// Quality=0ȂoCpX
	if (Quality==0) {
		if (IsANSI) {
			return GetTextExtentPoint32A(hdc, (LPCSTR)lpString,cbString,lpSize);
		} else {
			return GetTextExtentPoint32W(hdc,(LPCWSTR)lpString,cbString,lpSize);
		}
	}

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);

	// tHgTCY2{/3{/4{ɂ
	switch(Quality){
	case 2:
		logCanvasFont.lfHeight *=  3;
		break;
	case 3:
		logCanvasFont.lfHeight <<= 2;
		break;
	default:
		logCanvasFont.lfHeight <<= 1;
	}
	logCanvasFont.lfWidth = 0;
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	// Ԃݒ肳Ă邩Ȃ̂ŐݒRs[
	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);
	// `悳镶̑傫擾
	if (IsANSI) {
		GetTextExtentPoint32A(hCanvasDC,(LPCSTR)lpString,cbString, &sizeString);
	} else {
		GetTextExtentPoint32W(hCanvasDC,(LPWSTR)lpString,cbString, &sizeString);
	}

	// iɉ2/3/4̔{ɂ낦
	switch(Quality){
	case 2:
		if ((sizeString.cx % 3) != 0) sizeString.cx += (3 - (sizeString.cx % 3));
		if ((sizeString.cy % 3) != 0) sizeString.cy += (3 - (sizeString.cy % 3));
		lpSize->cx  = sizeString.cx / 3;
		lpSize->cy = sizeString.cy / 3;
		break;
	case 3:
		if ((sizeString.cx % 4) != 0) sizeString.cx += (4 - (sizeString.cx % 4));
		if ((sizeString.cy % 4) != 0) sizeString.cy += (4 - (sizeString.cy % 4));
		lpSize->cx  = sizeString.cx >> 2;
		lpSize->cy = sizeString.cy >> 2;
		break;
	default:
		if ((sizeString.cx % 2) != 0) sizeString.cx += (2 - (sizeString.cx % 2));
		if ((sizeString.cy % 2) != 0) sizeString.cy += (2 - (sizeString.cy % 2));
		lpSize->cx  = sizeString.cx >> 1;
		lpSize->cy = sizeString.cy >> 1;
	}
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	DeleteObject(hCanvasFont);
	DeleteDC(hCanvasDC);
	return TRUE;
}

/*
// LCTextOutiДj
BOOL ExtTextOutEx(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPVOID lpString, UINT cbString, CONST INT *lpDx, BOOL IsANSI)
{
	int x, y, px, py, y1, y2, y3;
	int lCanvasWidth,lCanvasHeight,lDestWidth,lDestHeight;
	int bytesPerScanline;
	int TextExtra;
	HDC hCanvasDC;
	BITMAPINFO bmpDIB;
	HBITMAP hCanvasBitmap, hPrevBitmap;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	SIZE sizeString;
	LPBYTE lpPixels;
	if (cbString==0) return FALSE;	

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// tHgTCYR{ɂ
	// ɕWA`GCAX𗘗piClearType𖳌
	logCanvasFont.lfHeight *= 3;
	logCanvasFont.lfWidth = 0;
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	// Ԃݒ肳Ă邩Ȃ̂ŐݒRs[
	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);

	// `悳镶̑傫擾
	if (IsANSI) {
		GetTextExtentPoint32A(hCanvasDC,(LPCSTR)lpString,cbString, &sizeString);
	} else {
		GetTextExtentPoint32W(hCanvasDC,(LPWSTR)lpString,cbString, &sizeString);
	}

	if ((fuOptions && ETO_CLIPPED) && ( lprc != NULL )) {
		lDestWidth = lprc->right;
		lDestHeight = lprc->bottom;
		lCanvasWidth = lDestWidth * 3;
		lCanvasHeight = lDestHeight * 3;
	} else {
	// 3̔{ɑ
		if ((sizeString.cx % 3) != 0) sizeString.cx += (3-(sizeString.cx % 3));
		if ((sizeString.cy % 3) != 0) sizeString.cy += (3-(sizeString.cy % 3));
		// ʂ̃TCY
		lCanvasWidth = sizeString.cx;
		lCanvasHeight = sizeString.cy;
		// `̃TCY
		lDestWidth = sizeString.cx / 3;
		lDestHeight = sizeString.cy / 3;
	}
}*/

// LCTextOutiДj
BOOL TextOutEx(HDC hdc, int nXStart, int nYStart, LPVOID lpString, int cbString, bool IsANSI)
{
	int lCanvasWidth,lCanvasHeight,lDestWidth,lDestHeight;
	int bytesPerScanline;
	int TextExtra;
	int lMapMode;
	HDC hCanvasDC;
	BITMAPINFO bmpDIB;
	HBITMAP hCanvasBitmap, hPrevBitmap;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	SIZE sizeString;
	LPBYTE lpPixels;

	// Quality=0ȂoCpX
	if (Quality==0) {
		if (IsANSI) {
			return TextOutA(hdc,nXStart,nYStart,(LPCSTR)lpString,cbString);
		} else {
			return TextOutW(hdc,nXStart,nYStart,(LPCWSTR)lpString,cbString);
		}
	}
	if (cbString==0) return FALSE;
	
	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);

	// Ô߃}bsO[hMM_TEXTɖ߂
	lMapMode = GetMapMode(hdc);
	SetMapMode(hdc, MM_TEXT);
	SetMapMode(hCanvasDC, MM_TEXT);
	// Ԃݒ肳Ă邩Ȃ̂ŐݒRs[
	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);

	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);

	// 2{/3{/4{
	switch(Quality){
	case 2:
		logCanvasFont.lfHeight *=  3;
		break;
	case 3:
		logCanvasFont.lfHeight <<= 2;
		break;
	default:
		logCanvasFont.lfHeight <<= 1;
	}
	logCanvasFont.lfWidth = 0;
	// ɕWA`GCAX𗘗piClearType𖳌
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	// tHg쐬đI
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);
	// `悳镶̑傫擾
	if (IsANSI) {
		GetTextExtentPoint32A(hCanvasDC,(LPCSTR)lpString,cbString, &sizeString);
	} else {
		GetTextExtentPoint32W(hCanvasDC,(LPWSTR)lpString,cbString, &sizeString);
	}
	// iɉ2/3/4̔{ɂ낦
	switch(Quality){
	case 2:
		if ((sizeString.cx % 3) != 0) sizeString.cx += (3 - (sizeString.cx % 3));
		if ((sizeString.cy % 3) != 0) sizeString.cy += (3 - (sizeString.cy % 3));
		lDestWidth  = sizeString.cx / 3;
		lDestHeight = sizeString.cy / 3;
		break;
	case 3:
		if ((sizeString.cx % 4) != 0) sizeString.cx += (4 - (sizeString.cx % 4));
		if ((sizeString.cy % 4) != 0) sizeString.cy += (4 - (sizeString.cy % 4));
		lDestWidth  = sizeString.cx >> 2;
		lDestHeight = sizeString.cy >> 2;
		break;
	default:
		if ((sizeString.cx % 2) != 0) sizeString.cx += (2 - (sizeString.cx % 2));
		if ((sizeString.cy % 2) != 0) sizeString.cy += (2 - (sizeString.cy % 2));
		lDestWidth  = sizeString.cx >> 1;
		lDestHeight = sizeString.cy >> 1;
	}
	// ʂ̃TCY
	lCanvasWidth = sizeString.cx;
	lCanvasHeight = sizeString.cy;
	// 32bppAȂ킿1sNZ=32rbg=4oCg
	bytesPerScanline = (lCanvasWidth << 2);
	// 32bppDIBSection쐬
	bmpDIB.bmiHeader.biSize = sizeof(bmpDIB.bmiHeader);
    bmpDIB.bmiHeader.biWidth = lCanvasWidth;
    bmpDIB.bmiHeader.biHeight = -lCanvasHeight;
    bmpDIB.bmiHeader.biPlanes = 1;
    bmpDIB.bmiHeader.biBitCount = 32;
    bmpDIB.bmiHeader.biCompression = BI_RGB;
    bmpDIB.bmiHeader.biSizeImage = bytesPerScanline * lCanvasHeight;
	hCanvasBitmap = (HBITMAP)CreateDIBSection(hdc, &bmpDIB, DIB_RGB_COLORS,(void **) &lpPixels, NULL, NULL);
	hPrevBitmap = (HBITMAP)SelectObject(hCanvasDC, hCanvasBitmap);
	// wi[h̏ꍇStretchBltŔwi炩ߓ]Ă
	if (GetBkMode(hdc) == TRANSPARENT) {
		SetBkMode(hCanvasDC, TRANSPARENT);
		StretchBlt(hCanvasDC, 0, 0, lCanvasWidth, lCanvasHeight, hdc, nXStart, nYStart, lDestWidth, lDestHeight, SRCCOPY); 
	} else {
		SetBkMode(hCanvasDC, OPAQUE);
		SetBkColor(hCanvasDC, GetBkColor(hdc));
		// wiOPAQUEłAŔ{ɑăTCY𒲐߂ĂꍇA
		// wiFœhԂȂȂ̂ŁAPatBltœhԂĂ
		HBRUSH hBrush;
		hBrush = CreateSolidBrush(GetBkColor(hdc));
		SelectObject(hCanvasDC, hBrush);
		PatBlt(hCanvasDC, 0, 0, lCanvasWidth, lCanvasHeight, SRCCOPY);
		SelectObject(hCanvasDC, GetStockObject(WHITE_BRUSH));
		DeleteObject(hBrush);
	}
	SetTextColor(hCanvasDC, GetTextColor(hdc));	

	// zmTextOutĂ
	// Weight=0: ftHgBʂ1`B
	// Weight=1: 1sNZɂ炵2`BƔZB
	// Weight=2: c1sNZ炵Čv4`BȂZB
	if (IsANSI) {
		switch(Weight) {
		case 2:
			TextOutA(hCanvasDC,0,0,(LPCSTR)lpString,cbString);
			TextOutA(hCanvasDC,1,0,(LPCSTR)lpString,cbString);
			break;
		case 3:
			TextOutA(hCanvasDC,0,0,(LPCSTR)lpString,cbString);
			TextOutA(hCanvasDC,1,0,(LPCSTR)lpString,cbString);
			TextOutA(hCanvasDC,0,1,(LPCSTR)lpString,cbString);
			TextOutA(hCanvasDC,1,1,(LPCSTR)lpString,cbString);
			break;
		default:
			TextOutA(hCanvasDC,0,0,(LPCSTR)lpString,cbString);
			TextOutA(hCanvasDC,0,0,(LPCSTR)lpString,cbString);
		}
	} else {
		switch(Weight) {
		case 2:
			TextOutW(hCanvasDC,0,0,(LPWSTR)lpString,cbString);
			TextOutW(hCanvasDC,1,0,(LPWSTR)lpString,cbString);
			break;
		case 3:
			TextOutW(hCanvasDC,0,0,(LPWSTR)lpString,cbString);
			TextOutW(hCanvasDC,1,0,(LPWSTR)lpString,cbString);
			TextOutW(hCanvasDC,0,1,(LPWSTR)lpString,cbString);
			TextOutW(hCanvasDC,1,1,(LPWSTR)lpString,cbString);
			break;
		default:
			TextOutW(hCanvasDC,0,0,(LPWSTR)lpString,cbString);
			TextOutW(hCanvasDC,0,0,(LPWSTR)lpString,cbString);
		}
	}

	// UseSubPixel=1: ClearTypeǂgpB
	// ԃ`lƐ`lꂼtɂ炵ĂB
	// ł́A[ƉE[̃sNZ̐FȂ\B
	// ́AUwiɕ`悵ĂA`ɃAt@uhĂȂB
	// {̂ق@Ȃ񂾂ǂAĂ܂BNL{k
	/*
	if (UseSubPixel==1) {
		// SubPixelDirection=0: TusNZRGB̏ɕłBLCD̕B
		// SubPixelDirection=1: TusNZBGȐɕłB͒LCDB
		if (SubPixelDirection==0) {
			// for(x = 4; x < (int)bmpDIB.bmiHeader.biSizeImage; x += 4) lpPixels[x - 4] = lpPixels[x];
			//for(x = bmpDIB.bmiHeader.biSizeImage - 4; x > 4; x -= 4) lpPixels[x + 2] = lpPixels[x - 2];	
		} else {
			//for(x = 4; x < (int)bmpDIB.bmiHeader.biSizeImage; x += 4) lpPixels[x - 2] = lpPixels[x + 2];
			//for(x = bmpDIB.bmiHeader.biSizeImage - 4; x > 4; x -= 4) lpPixels[x] = lpPixels[x - 4];	
		}
	}
	*/

	// k[`
	int x, y, px, py, y1, y2, y3, y4;
	px = 0;
	py = 0;
	y1 = 0;
	y2 = 0;
	y3 = 0;
	y4 = 0;
	switch(Quality) {
	case 2:
		for(y = 0; y < lCanvasHeight; y += 3){
			px = 0;
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			for(x = 0; x < bytesPerScanline; x += 12){
				lpPixels[px + py + 0] = ColorTable3x[lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1]
												   + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2]
												   + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3]];
				lpPixels[px + py + 1] = ColorTable3x[lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1]
												   + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2]
												   + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3]];
				lpPixels[px + py + 2] = ColorTable3x[lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1]
												   + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2]
												   + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3]];
				px += 4;
			}
			py += bytesPerScanline;
			y1 = y3 + bytesPerScanline;
		}
		break;
	case 3:
		for(y = 0; y < lCanvasHeight; y += 4){
			px = 0;
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			y4 = y3 + bytesPerScanline;
			for(x = 0; x < bytesPerScanline; x += 16){
				lpPixels[px + py + 0] = (lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1] + lpPixels[12 + x + y1]
									   + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2] + lpPixels[12 + x + y2]
									   + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3] + lpPixels[12 + x + y3]
									   + lpPixels[0 + x + y4] + lpPixels[4 + x + y4] + lpPixels[ 8 + x + y4] + lpPixels[12 + x + y4]) >> 4;
				lpPixels[px + py + 1] = (lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1] + lpPixels[13 + x + y1]
									   + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2] + lpPixels[13 + x + y2]
									   + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3] + lpPixels[13 + x + y3]
									   + lpPixels[1 + x + y4] + lpPixels[5 + x + y4] + lpPixels[ 9 + x + y4] + lpPixels[13 + x + y4]) >> 4;
				lpPixels[px + py + 2] = (lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1] + lpPixels[14 + x + y1]
									   + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2] + lpPixels[14 + x + y2]
									   + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3] + lpPixels[14 + x + y3]
									   + lpPixels[2 + x + y4] + lpPixels[6 + x + y4] + lpPixels[10 + x + y4] + lpPixels[14 + x + y4]) >> 4;
				px += 4;
			}
			py += bytesPerScanline;
			y1 = y4 + bytesPerScanline;
		}
		break;
	default:
		for(y = 0; y < lCanvasHeight; y += 2){
			px = 0;
			y2 = y1 + bytesPerScanline;
			for(x = 0; x < bytesPerScanline; x += 8){
				lpPixels[px + py + 0] = (lpPixels[0 + x + y1] + lpPixels[4 + x + y1]
									   + lpPixels[0 + x + y2] + lpPixels[4 + x + y2]) >> 2;
				lpPixels[px + py + 1] = (lpPixels[1 + x + y1] + lpPixels[5 + x + y1]
									   + lpPixels[1 + x + y2] + lpPixels[5 + x + y2]) >> 2;
				lpPixels[px + py + 2] = (lpPixels[2 + x + y1] + lpPixels[6 + x + y1]
									   + lpPixels[2 + x + y2] + lpPixels[6 + x + y2]) >> 2;
				px += 4;
			}
			py += bytesPerScanline;
			y1 = y2 + bytesPerScanline;
		}
	}

	// ]
	BitBlt(hdc,nXStart,nYStart,lDestWidth,lDestHeight,hCanvasDC,0,0,SRCCOPY);
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	SelectObject(hCanvasDC, hPrevBitmap);
	DeleteObject(hCanvasFont);
	DeleteObject(hCanvasBitmap);
	DeleteDC(hCanvasDC);
	SetMapMode(hdc, lMapMode);
	return TRUE;
}

BOOL WINAPI d_GetTextExtentPoint32A(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	// ANSIGetTextExtentPoint32
	return GetTextExtentPoint32Ex(hdc,(LPVOID)lpString,cbString,lpSize,TRUE);
}

BOOL WINAPI d_GetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	// UnicodeGetTextExtentPoint32
	return GetTextExtentPoint32Ex(hdc,(LPVOID)lpString,cbString,lpSize,FALSE);
}

/*
BOOL WINAPI d_ExtTextOutA(HDC hdc, int X, int Y, UINT fuOptions, CONST RECT *lprc, LPCSTR lpString, UINT cbCount, CONST INT *lpDx)
{
	// ANSITextOut
	return ExtTextOutEx(hdc, X, Y, fuOptions, lprc, (LPVOID)lpString, cbCount, lpDx, TRUE);
}

BOOL WINAPI d_ExtTextOutW(HDC hdc, int X, int Y, UINT fuOptions, CONST RECT *lprc, LPCWSTR lpString, UINT cbCount, CONST INT *lpDx)
{
	// UnicodeTextOut
	return ExtTextOutEx(hdc, X, Y, fuOptions, lprc, (LPVOID)lpString, cbCount, lpDx, FALSE);
}*/

BOOL WINAPI d_TextOutA(HDC hdc, int nXStart, int nYStart, LPCSTR lpString, int cbString)
{
	// ANSITextOut
	return TextOutEx(hdc, nXStart, nYStart, (LPVOID)lpString, cbString, TRUE);
}

BOOL WINAPI d_TextOutW(HDC hdc, int nXStart, int nYStart, LPCWSTR lpString, int cbString)
{
	// UnicodeTextOut
	return TextOutEx(hdc, nXStart, nYStart, (LPVOID)lpString, cbString, FALSE);
}
